// SHIFT-JISt@Cpre^OɑΉUTF-8eLXgt@Cɕϊ
// t@C̎w̓hbO&hbOɂ
// VC2008/VC2013 Express  32/64bit Unicode

#include <windows.h>
#include <commctrl.h> 
#include <stdio.h>
#include <tchar.h>
#include <shlobj.h>
#include <shlwapi.h>
#include "resource.h"

#pragma comment(lib,"shlwapi.lib")

#define WM_DPICHANGED                   0x02E0
typedef enum MONITOR_DPI_TYPE {
	MDT_EFFECTIVE_DPI = 0,
	MDT_ANGULAR_DPI = 1,
	MDT_RAW_DPI = 2,
	MDT_DEFAULT = MDT_EFFECTIVE_DPI
} MONITOR_DPI_TYPE;


#ifndef _DPI_AWARENESS_CONTEXTS_
DECLARE_HANDLE(DPI_AWARENESS_CONTEXT);
#endif
typedef HRESULT(_stdcall *GetDpiForMonitorFunc)(HMONITOR, MONITOR_DPI_TYPE, UINT *, UINT *);
typedef HRESULT(_stdcall* EnableNonClientDpiScalingFunc)(HWND);
typedef HRESULT(_stdcall* SetThreadDpiAwarenessContextFunc)(DPI_AWARENESS_CONTEXT);
typedef BOOL(_stdcall *SetProcessDPIAwareFunc)(VOID);

HMODULE hModUser32 = 0;
SetThreadDpiAwarenessContextFunc ThreadAwareFunc = 0;
static EnableNonClientDpiScalingFunc NCCfunc = 0;


#ifndef _DPI_AWARENESS_CONTEXTS_

typedef enum _DPI_AWARENESS {
	DPI_AWARENESS_INVALID = -1,
	DPI_AWARENESS_UNAWARE = 0,
	DPI_AWARENESS_SYSTEM_AWARE = 1,
	DPI_AWARENESS_PER_MONITOR_AWARE = 2
} DPI_AWARENESS;

#define DPI_AWARENESS_CONTEXT_UNAWARE              ((DPI_AWARENESS_CONTEXT)-1)
#define DPI_AWARENESS_CONTEXT_SYSTEM_AWARE         ((DPI_AWARENESS_CONTEXT)-2)
#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE    ((DPI_AWARENESS_CONTEXT)-3)
#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2 ((DPI_AWARENESS_CONTEXT)-4)
#define DPI_AWARENESS_CONTEXT_UNAWARE_GDISCALED    ((DPI_AWARENESS_CONTEXT)-5)

#endif

#define BUF_MAX 1024


int pretxt(TCHAR* dtc_file,TCHAR* src_file);

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

TCHAR* file=0;
int win10ver2(void);
int WIN10VER;

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,TCHAR* lpszCmdLine, int nCmdShow){
	TCHAR f[MAX_PATH];
	if(lpszCmdLine[0]){
		if(lpszCmdLine[0]==_T('\"')){
			_tcscpy_s(f,sizeof(f)/sizeof(TCHAR),lpszCmdLine+1);
			f[ _tcslen(f) -1]=_T('\0');
			file=f;
		}else
			file=lpszCmdLine;
	}
	WIN10VER = win10ver2();
	hModUser32 = LoadLibrary(L"User32.dll");
	if (hModUser32){
		NCCfunc = (EnableNonClientDpiScalingFunc)GetProcAddress(hModUser32, "EnableNonClientDpiScaling");
		if (WIN10VER == 1607)	//	AnniversaryUpdate
			NCCfunc = (EnableNonClientDpiScalingFunc)GetProcAddress(hModUser32, "EnableNonClientDpiScaling");
		else
			NCCfunc = 0;
		if (ThreadAwareFunc){
			if (WIN10VER<1703)
				(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE);
			if (1703 <= WIN10VER && WIN10VER<1809)
				(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2);
			if (1809 <= WIN10VER)
				(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_UNAWARE_GDISCALED);
		}
		else{	//	Windows Vistaȍ~
			SetProcessDPIAwareFunc ProcessAwareFunc = (SetProcessDPIAwareFunc)GetProcAddress(hModUser32, "SetProcessDPIAware");
			if (ProcessAwareFunc)
				(*ProcessAwareFunc)();
		}


	}
	DialogBox(hInstance, TEXT("DLG1"), 0, (DLGPROC)DlgProc1);
	if (hModUser32)
		FreeLibrary(hModUser32);
	return 0;
}
BOOL GetActualDialogBaseUnits(HWND hDialog, SIZE *baseUnit){
	RECT rect;
	BOOL result;

	rect.left = 4;
	rect.top = 8;
	if (result = MapDialogRect(hDialog, &rect)) {
		baseUnit->cx = rect.left;
		baseUnit->cy = rect.top;
	}
	return result;
}

struct DLG_CHILD_SCALE{
	HWND hDlg;
	SIZE unit;
	UINT oldScale;
	UINT newScale;
	HFONT hFont;
};
//	eEBhE(Rg[̈ړyё傫̕ύX
BOOL CALLBACK EnumWndProc(HWND hWnd, LPARAM lParam){
	POINT pt;
	DLG_CHILD_SCALE* d = (DLG_CHILD_SCALE*)lParam;
	pt.x = 0;
	pt.y = 0;
	ClientToScreen(hWnd, &pt);
	ScreenToClient(d->hDlg, &pt);
	RECT rc;
	GetClientRect(hWnd, &rc);
	int cx, cy, w, h;
	cx = MulDiv(pt.x, 4, d->unit.cx);
	cy = MulDiv(pt.y, 8, d->unit.cy);

	cx = MulDiv(cx, d->newScale, d->oldScale);
	cy = MulDiv(cy, d->newScale, d->oldScale);

	cx = MulDiv(cx, d->unit.cx, 4);
	cy = MulDiv(cy, d->unit.cy, 8);

	w = MulDiv(rc.right, d->newScale, d->oldScale);
	h = MulDiv(rc.bottom, d->newScale, d->oldScale);

	rc.left = cx;
	rc.top = cy;
	rc.right = cx + w;
	rc.bottom = cy + h;
	LONG style = GetWindowLong(hWnd, GWL_STYLE);
	LONG exStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
	AdjustWindowRectEx(&rc, style, FALSE, exStyle);
	SetWindowPos(hWnd, NULL, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, SWP_NOZORDER);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)d->hFont, MAKELPARAM(TRUE, 0));
	UpdateWindow(hWnd);
	return TRUE;
}
//	DPIXP[̕ύX
HFONT scaleChange(HWND hDlg, int nowScale, int oldScale, SIZE& baseUnit, HFONT hFont){
	LOGFONT lf;
	HDC hdc = GetDC(GetDlgItem(hDlg, IDC_LISTBOX1));
	HFONT hfont9 = (HFONT)SendMessage(GetDlgItem(hDlg, IDOK), WM_GETFONT, 0, 0);
	GetObject(hfont9, sizeof(LOGFONT), &lf);
	int height;
	height = lf.lfHeight * 100 / oldScale;
	lf.lfHeight = (height)*nowScale;
	lf.lfHeight /= 100;
	HFONT hFont2 = CreateFontIndirect(&lf);
	LOGFONT lfont;
	HFONT hFontOld = (HFONT)SelectObject(hdc, hFont2);

	TEXTMETRIC metrics;
	GetTextMetrics(hdc, &metrics);
	SelectObject(hdc, hFontOld);

	HFONT htemp = (HFONT)SendMessage(hDlg, WM_GETFONT, 0, 0);
	GetObject(htemp, sizeof(LOGFONT), &lfont);
	ReleaseDC(hDlg, hdc);

	RECT rc;
	GetClientRect(hDlg, &rc);
	int w = rc.right - rc.left;
	int h = rc.bottom - rc.top;
	w = MulDiv(w, nowScale, oldScale);
	h = MulDiv(h, nowScale, oldScale);

	rc.left = 0;
	rc.top = 0;
	rc.right = w;
	rc.bottom = h;

	LONG style = GetWindowLong(hDlg, GWL_STYLE);
	AdjustWindowRectEx(&rc, style, FALSE, 0);

	DLG_CHILD_SCALE d;
	d.hDlg = hDlg;
	d.hFont = hFont2;
	d.newScale = nowScale;
	d.oldScale = oldScale;
	d.unit = baseUnit;

	InvalidateRect(hDlg, NULL, FALSE);
	UpdateWindow(hDlg);
	if (hFont)
		DeleteObject(hFont);
	return hFont = hFont2;
}

//	_CAO{bNX̃vV[W[

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	TCHAR buf[MAX_PATH];
	HDROP hDrop;
	UINT fmax;
	int	i;
	static HFONT hFont = 0;
	static int nowDPIx = 96;
	static int nowDPIy = 96;
	static UINT nowScale = 100;
	static UINT initScale = 100;
	static int height;
	static HMODULE hMod;
	static GetDpiForMonitorFunc func = 0;
	static SIZE baseUnit;
	switch (msg) {
		case WM_INITDIALOG:{
			DragAcceptFiles(hDlg, TRUE);
			if (file)
				SendMessage(GetDlgItem(hDlg, IDC_LISTBOX1), LB_ADDSTRING, 0, (LPARAM)file);
			HMONITOR hMonitor = MonitorFromWindow(hDlg, MONITOR_DEFAULTTONULL);
			hMod = LoadLibrary(L"Shcore.dll");

			func = (GetDpiForMonitorFunc)GetProcAddress(hMod, "GetDpiForMonitor");
			if (func == 0)
				FreeLibrary(hMod);
			if (WIN10VER < 1703){
				UINT hDPI, vDPI;
				if (func)
					(*func)(hMonitor, MDT_EFFECTIVE_DPI, &hDPI, &vDPI);
				else{
					HDC hdc = GetDC(NULL);	//	fBXNgbv
					hDPI = GetDeviceCaps(hdc, LOGPIXELSX);
					vDPI = GetDeviceCaps(hdc, LOGPIXELSY);
				}
				nowDPIx = hDPI;
				nowDPIy = vDPI;
				nowScale = MulDiv(nowDPIx, 100, 96);
				GetActualDialogBaseUnits(hDlg, &baseUnit);
				UINT oldScale = nowScale;
				hFont = scaleChange(hDlg, nowScale, oldScale, baseUnit, hFont);
			}
			return TRUE;
		}
		case WM_DPICHANGED:{
			if (WIN10VER < 1703){
			   UINT oldScale = nowScale;
			   nowDPIx = LOWORD(wParam);
			   nowDPIy = HIWORD(wParam);
			   nowScale = MulDiv(nowDPIx, 100, 96);
			   hFont = scaleChange(hDlg, nowScale, oldScale, baseUnit, hFont);
			}
			break;
		}
		case WM_NCCREATE:{
			if (NCCfunc)
				(*NCCfunc)(hDlg);
			return FALSE;
		}
		case WM_DROPFILES:
			hDrop = (HDROP)wParam;
			fmax = DragQueryFile((HDROP)wParam, 0xFFFFFFFF, NULL, 0);
			for(i = 0; i < (int)fmax; i++) {
				DragQueryFile(hDrop, i, buf, sizeof(buf)/sizeof(TCHAR));
				SendMessage(GetDlgItem(hDlg,IDC_LISTBOX1) , LB_ADDSTRING , 0 , (LPARAM)buf);
			}
			DragFinish(hDrop);
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDOK:
					fmax=(UINT)SendMessage(GetDlgItem(hDlg,IDC_LISTBOX1) ,LB_GETCOUNT,0,0);
					for(i = 0; i < (int)fmax; i++){
						SendMessage(GetDlgItem(hDlg,IDC_LISTBOX1) ,LB_GETTEXT,i,(LPARAM)buf);
						TCHAR dtc_file[MAX_PATH];
						_tcscpy_s(dtc_file,sizeof(dtc_file)/sizeof(TCHAR),buf);
						TCHAR ext[MAX_PATH];
						TCHAR* p=PathFindExtension(dtc_file);	//	gq擾
						if (p==NULL){
							_tcscpy_s(ext, sizeof(ext) / sizeof(TCHAR), _TEXT("non"));
						}else{
							_tcscpy_s(ext, sizeof(ext) / sizeof(TCHAR), p);
						}
						PathRemoveExtension(dtc_file);	//gq菜
						_tcscat_s(dtc_file, sizeof(dtc_file) / sizeof(TCHAR), _TEXT(" "));
						_tcscat_s(dtc_file, sizeof(dtc_file) / sizeof(TCHAR), ext);
						_tcscat_s(dtc_file, sizeof(dtc_file) / sizeof(TCHAR), _TEXT("_utf8.txt"));
						pretxt(dtc_file,buf);
					}
					EndDialog(hDlg, TRUE);
					return TRUE;
				case IDCANCEL:
					EndDialog(hDlg,FALSE);
					return FALSE;
				default:
					return FALSE;
			}
			default:
				return FALSE;
	}
	return TRUE;
}

//	src_fileŎS-JISt@CJHTMLpre^Oɍ킹ɕϊUTF-8ŕۑ

int pretxt(TCHAR* dtc_file,TCHAR* src_file){
	TCHAR utf16[BUF_MAX*2];
	TCHAR dtc[BUF_MAX*2];
	FILE* src_fp;
	FILE* dtc_fp;

	int f=0;

	if(_tfopen_s(&src_fp,src_file,_TEXT("r"))){
		return -1;

	}
	if(_tfopen_s(&dtc_fp,dtc_file,_TEXT("w, ccs=UTF-8"))){
		fclose(src_fp);
		return -1;
	}
	_ftprintf(dtc_fp, _TEXT("<pre><code>"));
	char sjis_buf[BUF_MAX*2];
	while( fgets(sjis_buf,BUF_MAX*2,src_fp) != NULL ){
		MultiByteToWideChar(932,0,sjis_buf,sizeof(sjis_buf),utf16,sizeof(utf16)/sizeof(TCHAR));
		TCHAR* src_p=utf16;
		TCHAR* dtc_p=dtc;
		while(*src_p){
			switch(*src_p){
			case _T('<'):
				*dtc_p++=_T('&');
				*dtc_p++=_T('l');
				*dtc_p++=_T('t');
				*dtc_p++=_T(';');
				break;
			case _T('>'):
				*dtc_p++=_T('&');
				*dtc_p++=_T('g');
				*dtc_p++=_T('t');
				*dtc_p++=_T(';');
				break;
			case _T('&'):
				*dtc_p++=_T('&');
				*dtc_p++=_T('a');
				*dtc_p++=_T('m');
				*dtc_p++=_T('p');
				*dtc_p++=_T(';');
				break;
			case _T('\"'):
				*dtc_p++=_T('&');
				*dtc_p++=_T('q');
				*dtc_p++=_T('u');
				*dtc_p++=_T('o');
				*dtc_p++=_T('t');
				*dtc_p++=_T(';');
				break;
			case _T('\\'):
				*dtc_p++ = _T('&');
				*dtc_p++ = _T('y');
				*dtc_p++ = _T('e');
				*dtc_p++ = _T('n');
				*dtc_p++ = _T(';');
				break;
			default:
				*dtc_p++=*src_p;
			}
			++src_p;
		}
		*dtc_p=_T('\0');
		_fputts(dtc,dtc_fp);
	}
	_ftprintf(dtc_fp, _TEXT("</code></pre>"));

	fclose(src_fp);
	fclose(dtc_fp);
	return 0;
}

//	DLL̊֐ւ̃|C^^`
typedef void (WINAPI *RtlGetVersion_FUNC)(OSVERSIONINFOEXW*);

int win10ver2(void){
	int ver = 0;
	HMODULE hMod;
	OSVERSIONINFOEXW osw;
	hMod = LoadLibrary(TEXT("ntdll.dll"));
	RtlGetVersion_FUNC func;
	if (hMod){
		func = (RtlGetVersion_FUNC)GetProcAddress(hMod, "RtlGetVersion");
		if (func == 0){
			FreeLibrary(hMod);
			return FALSE;
		}
		ZeroMemory(&osw, sizeof(osw));
		osw.dwOSVersionInfoSize = sizeof(osw);
		func(&osw);
		FreeLibrary(hMod);
		if (osw.dwMajorVersion == 10){
			switch (osw.dwBuildNumber){
			case 10240: ver = 1507; break;
			case 10586: ver = 1511; break;
			case 14393: ver = 1607; break;
			case 15063: ver = 1703; break;
			case 16299: ver = 1709; break;
			case 17134: ver = 1803; break;
			case 17763: ver = 1809; break;
			default: ver = 1809; break;
			}
			return ver;
		}
	}
	return -1;
}